
<p align="middle"><img src="https://daybrush.com/scenejs/images/clapperboard.png" width="250"/></p>
<h2 align="middle">Scene.js</h2>
<p align="middle">
<a href="https://opencollective.com/scenejs" alt="Financial Contributors on Open Collective"><img src="https://opencollective.com/scenejs/all/badge.svg?label=financial+contributors" /></a>
<a href="https://www.npmjs.com/package/scenejs" target="_blank"><img src="https://img.shields.io/npm/v/scenejs.svg?style=flat-square&color=007acc&label=version" alt="npm version" /></a>
<img src="https://img.shields.io/badge/language-typescript-blue.svg?style=flat-square"/>
<a href="https://travis-ci.org/daybrush/scenejs" target="_blank"><img alt="Travis (.org)" src="https://img.shields.io/travis/daybrush/scenejs.svg?style=flat-square&label=build" /></a>
<a href="https://github.com/daybrush/scenejs/blob/master/LICENSE" target="_blank"><img src="https://img.shields.io/github/license/daybrush/scenejs.svg?style=flat-square&label=license&color=08CE5D"/></a>
</p>


<p align="middle">🎬 Scene.js is an JavaScript & CSS timeline-based animation library.</p>

<p align="middle"><a href="https://daybrush.com/scenejs"><strong>Official Site</strong></a> &nbsp;/&nbsp; <a href="https://daybrush.com/scenejs/release/latest/doc"><strong>API</strong></a> &nbsp;/&nbsp; <a href="https://daybrush.com/scenejs/features.html"><strong>Features</strong></a> &nbsp;/&nbsp; <a href="https://codepen.io/collection/DLWxrd/"><strong>Examples</strong></a></p>
<p align="middle"><strong>Translations</strong>: <a href="https://github.com/daybrush/scenejs/blob/master/README.md">🇺🇸</a> <a href="https://github.com/daybrush/scenejs/blob/master/README_CN.md">🇨🇳</a></p>
<br/>
<p align="middle" style="max-width: 1000px; margin: 0px auto;" >
  <a href="https://codepen.io/daybrush/pen/arQpYb" target="_blank"><img src="https://daybrush.com/scenejs/images/daybrush.gif" width="280" style="min-width:200px;max-width:320px;width: 32%;"/></a>&nbsp;
  <a href="https://codepen.io/daybrush/pen/EQPPBg" target="_blank"><img src="https://daybrush.com/scenejs/images/tree.gif" width="280" style="min-width:200px;max-width:320px;width: 32%;"/></a>&nbsp;
  <a href="https://codepen.io/daybrush/pen/QYRyMd" target="_blank"><img src="https://daybrush.com/scenejs/images/card.gif" width="280" style="min-width:200px;max-width:320px;width: 32%;"/></a>&nbsp;
  <a href="https://codepen.io/daybrush/pen/zWMeJW" target="_blank"><img src="https://daybrush.com/scenejs/images/circleburst.gif" width="280" style="min-width:200px;max-width:320px;width: 32%;"/></a>&nbsp;
  <a href="https://codepen.io/daybrush/pen/aYPjjM" target="_blank"><img src="https://daybrush.com/scenejs/example/scenejs.gif" width="280" style="min-width:200px;max-width:320px;width: 32%;"/></a>&nbsp;
  <a href="https://codepen.io/daybrush/pen/ydMJKR" target="_blank"><img src="https://daybrush.com/scenejs/images/panda.gif" width="280" style="min-width:200px;max-width:320px;width: 32%;"/></a>&nbsp;
  <a href="https://codepen.io/daybrush/pen/vRrbXG" target="_blank"><img src="https://daybrush.com/scenejs/example/raindrop.gif" width="280" style="min-width:200px;max-width:320px;width: 32%;"/></a>&nbsp;
  <a href="https://codepen.io/daybrush/pen/RMBXBm" target="_blank"><img src="https://daybrush.com/scenejs/example/search.gif" width="280" style="min-width:200px;max-width:320px;width: 32%;"/></a>&nbsp;
  <a href="https://codepen.io/daybrush/pen/pLxQGY" target="_blank"><img src="https://daybrush.com/scenejs/example/motion.gif" width="280" style="min-width:200px;max-width:320px;width: 32%;"/></a>&nbsp;
</p>


## 🚀 Examples
* [ClapperBoard Animation](https://codepen.io/daybrush/pen/VRomqr)
* [Panda eating Bamboo Animation](https://codepen.io/daybrush/pen/ydMJKR)
* [Circle Burst](https://codepen.io/daybrush/pen/zWMeJW)
* [Motion Effect](https://codepen.io/daybrush/pen/pLxQGY)
* [Tree Animation](https://codepen.io/daybrush/pen/EQPPBg)
* [Snow Animation](https://codepen.io/daybrush/pen/eoYGrx)
* [Card Rotation](https://codepen.io/daybrush/pen/QYRyMd)
* [Raindrop Effect](https://codepen.io/daybrush/pen/vRrbXG)
* [Cube](https://codepen.io/daybrush/pen/ybxwpV)
* [Shape](https://codepen.io/daybrush/pen/VXVgpE) 
* [Timer](https://codepen.io/daybrush/pen/OdMMXd)

[**More Examples**](https://codepen.io/collection/DLWxrd/)



## ⚙️ Installation
```bash
$ npm install scenejs
```
```html
<script src="//daybrush.com/scenejs/release/latest/dist/scene.min.js"></script>
```

## 📄 Documents
* [API Documentation](https://daybrush.com/scenejs/release/latest/doc/)
* [Features Documentation](https://daybrush.com/scenejs/features.html)

## 📦 Packages
|Package|Version|Description|
|---|---|---|
|[**react-scenejs**](https://github.com/daybrush/scenejs/tree/master/packages/react-scenejs)|[![](https://img.shields.io/npm/v/react-scenejs.svg?style=flat-square)](https://npmjs.com/package/react-scenejs)|A React Component that create JavaScript & CSS timeline-based animation with Scene.js.|
|[**ngx-scenejs**](https://github.com/daybrush/scenejs/tree/master/packages/ngx-scenejs)|[![](https://img.shields.io/npm/v/ngx-scenejs.svg?style=flat-square)](https://npmjs.com/package/ngx-scenejs)|An Angular Component that create JavaScript & CSS timeline-based animation with Scene.js.|
|[**vue-scenejs**](https://github.com/daybrush/scenejs/tree/master/packages/vue-scenejs)|[![](https://img.shields.io/npm/v/vue-scenejs.svg?style=flat-square)](https://npmjs.com/package/vue-scenejs)|A Vue Component that create JavaScript & CSS timeline-based animation with Scene.js.|
|[**preact-scenejs**](https://github.com/daybrush/scenejs/tree/master/packages/preact-scenejs)|[![](https://img.shields.io/npm/v/preact-scenejs.svg?style=flat-square)](https://npmjs.com/package/preact-scenejs)|A Preact Component that create JavaScript & CSS timeline-based animation with Scene.js.|
|[**@scenejs/effects**](https://github.com/daybrush/scenejs-effects)|[![](https://img.shields.io/npm/v/@scenejs/effects.svg?style=flat-square)](https://npmjs.com/package/@scenejs/effects)|Effect collection library where you can add scene effects to Scene.js.|
|[**@scenejs/timeline**](https://github.com/daybrush/scenejs-timeline)|[![](https://img.shields.io/npm/v/@scenejs/timeline.svg?style=flat-square)](https://npmjs.com/package/@scenejs/timeline)|A library that represents the timeline of Scene.js. You can control time, properties, and items.|
|[**@scenejs/media**](https://github.com/daybrush/scenejs-media)|[![](https://img.shields.io/npm/v/@scenejs/media.svg?style=flat-square)](https://npmjs.com/package/@scenejs/media)|A library for playing or controlling media with Scene.js.|
|[**@scenejs/iframe**](https://github.com/daybrush/scenejs-iframe)|[![](https://img.shields.io/npm/v/@scenejs/iframe.svg?style=flat-square)](https://npmjs.com/package/@scenejs/iframe)|A library that control the animation of iframe with Scene.js.|
|[**@scenejs/render**](https://github.com/daybrush/scenejs-render)|[![](https://img.shields.io/npm/v/@scenejs/render.svg?style=flat-square)](https://npmjs.com/package/@scenejs/render)|Make a movie of CSS animation through Scene.js.|

## 🎬 Make scene
```javascript
import Scene from "scenejs";

const scene = new Scene({
  ".class": {
    0: "left: 0px; top: 0px; transform: translate(0px);",
    1: {
      "left": "100px",
      "top": "0px",
      transform: "translate(50px)",
    },
    2: {
      "left": "200px",
      "top": "100px",
      transform: {
        translate: "100px",
      },
    }
  }
}, {
  selector: true,
  easing: "ease-in-out",
}).play();

```
## ✨ Effects

* [typing](https://daybrush.com/scenejs/features.html#typing)
* [flip](https://daybrush.com/scenejs/features.html#flip)
* [flipX](https://daybrush.com/scenejs/features.html#flipx)
* [flipY](https://daybrush.com/scenejs/features.html#flipy)
* [shake](https://daybrush.com/scenejs/features.html#shake)
* [shakeX](https://daybrush.com/scenejs/features.html#shakex)
* [shakeY](https://daybrush.com/scenejs/features.html#shakey)
* [wipeIn](https://daybrush.com/scenejs/features.html#wipein)
* [wipeOut](https://daybrush.com/scenejs/features.html#wipeout)
* [zoomIn](https://daybrush.com/scenejs/features.html#zoomin)
* [zoomOut](https://daybrush.com/scenejs/features.html#zoomout)
* [blink](https://daybrush.com/scenejs/features.html#bllink)
* [fadeIn](https://daybrush.com/scenejs/features.html#fadein)
* [fadeOut](https://daybrush.com/scenejs/features.html#fadeout)
* [transition](https://daybrush.com/scenejs/features.html#transition)


## 🌐 Supported Browsers

|Internet Explorer|Chrome|FireFox|Safari|Opera|
|---|---|---|---|---|
|9+(10+ playCSS)|latest|latest|latest|latest|

## ⭐️ Show Your Support
Please give a ⭐️ if this project helped you!

## 👏 Contributing

If you have any questions or requests or want to contribute to `scenejs` or other packages, please write the issue or give me a Pull Request freely.

## 🐞 Bug Report

If you find a bug, please report to us opening a new [Issues](https://github.com/daybrush/scenejs/issues) on GitHub.


## Contributors

### Code Contributors

This project exists thanks to all the people who contribute. [[Contribute](CONTRIBUTING.md)].
<a href="https://github.com/daybrush/scenejs/graphs/contributors"><img src="https://opencollective.com/scenejs/contributors.svg?width=890&button=false" /></a>

### Financial Contributors

Become a financial contributor and help us sustain our community. [[Contribute](https://opencollective.com/scenejs/contribute)]

#### Individuals

<a href="https://opencollective.com/scenejs"><img src="https://opencollective.com/scenejs/individuals.svg?width=890"></a>

#### Organizations

Support this project with your organization. Your logo will show up here with a link to your website. [[Contribute](https://opencollective.com/scenejs/contribute)]

<a href="https://opencollective.com/scenejs/organization/0/website"><img src="https://opencollective.com/scenejs/organization/0/avatar.svg"></a>
<a href="https://opencollective.com/scenejs/organization/1/website"><img src="https://opencollective.com/scenejs/organization/1/avatar.svg"></a>
<a href="https://opencollective.com/scenejs/organization/2/website"><img src="https://opencollective.com/scenejs/organization/2/avatar.svg"></a>
<a href="https://opencollective.com/scenejs/organization/3/website"><img src="https://opencollective.com/scenejs/organization/3/avatar.svg"></a>
<a href="https://opencollective.com/scenejs/organization/4/website"><img src="https://opencollective.com/scenejs/organization/4/avatar.svg"></a>
<a href="https://opencollective.com/scenejs/organization/5/website"><img src="https://opencollective.com/scenejs/organization/5/avatar.svg"></a>
<a href="https://opencollective.com/scenejs/organization/6/website"><img src="https://opencollective.com/scenejs/organization/6/avatar.svg"></a>
<a href="https://opencollective.com/scenejs/organization/7/website"><img src="https://opencollective.com/scenejs/organization/7/avatar.svg"></a>
<a href="https://opencollective.com/scenejs/organization/8/website"><img src="https://opencollective.com/scenejs/organization/8/avatar.svg"></a>
<a href="https://opencollective.com/scenejs/organization/9/website"><img src="https://opencollective.com/scenejs/organization/9/avatar.svg"></a>

## 📝 License

This project is [MIT](https://github.com/daybrush/scenejs/blob/master/LICENSE) licensed.

```
MIT License

Copyright (c) 2016 Daybrush

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
```
