import EventTrigger from "./EventTrigger";
import { IterationCountType, DirectionType, AnimatorState, EasingFunction, FillModeType, PlayStateType, EasingType, AnimatorOptions } from "./types";
export declare function isDirectionReverse(iteration: number, iteraiontCount: IterationCountType, direction: DirectionType): boolean;
declare class Animator<T extends AnimatorOptions = AnimatorOptions, U extends AnimatorState = AnimatorState> extends EventTrigger {
    state: U;
    private timerId;
    constructor(options?: Partial<T & AnimatorOptions>);
    setEasing(curveArray: string | number[] | EasingFunction): this;
    setOptions(options?: Partial<AnimatorOptions>): this;
    getTotalDuration(): number;
    getActiveDuration(delay?: boolean): number;
    isEnded(): boolean;
    isPaused(): boolean;
    start(delay?: number): boolean;
    play(toTime?: number): this;
    pause(): this;
    finish(): this;
    end(): this;
    setTime(time: number | string, isTick?: boolean, isParent?: boolean): this;
    getTime(): number;
    getUnitTime(time: string | number): number;
    isDelay(): boolean;
    setIteration(iterationCount: number): this;
    protected calculate(): this;
    private tick;
}
interface Animator<T extends AnimatorOptions = AnimatorOptions, U extends AnimatorState = AnimatorState> {
    setId(id: number | string): this;
    getId(): number | string;
    getIterationTime(): number;
    setIterationTime(time: number): this;
    setDelay(delay: number): this;
    getDelay(): number;
    setFillMode(fillMode: FillModeType): this;
    getFillMode(): FillModeType;
    setIterationCount(iterationCount: IterationCountType): this;
    getIterationCount(): IterationCountType;
    setDirection(direction: DirectionType): this;
    getDirection(): DirectionType;
    setPlayState(playState: PlayStateType): this;
    getPlayState(): PlayStateType;
    setPlaySpeed(playSpeed: number): this;
    getPlaySpeed(): number;
    setDuration(duration: number): this;
    getDuration(): number;
    getEasing(): EasingType;
    getEasingName(): string;
}
export default Animator;
