import Animator from "./Animator";
import SceneItem from "./SceneItem";
import { IObject } from "@daybrush/utils";
import { AnimateElement, SceneState, SceneOptions, EasingType, AnimatorState, SceneItemOptions, PlayCondition } from "./types";
import Frame from "./Frame";
import ListMap from "list-map";
declare class Scene extends Animator<SceneOptions, SceneState> {
    static VERSION: string;
    items: ListMap<Scene | SceneItem>;
    temp: IObject<Frame>;
    constructor(properties?: {
        options?: Partial<SceneOptions>;
    } & IObject<any>, options?: Partial<SceneOptions>);
    getDuration(): number;
    setDuration(duration: number): this;
    getItem<T extends (Scene | SceneItem) = Scene | SceneItem>(name: number | string): T;
    newItem(name: number | string, options?: Partial<SceneItemOptions>): Scene | SceneItem;
    removeItem(name: number | string): this;
    setItem(name: number | string, item: Scene | SceneItem): this;
    setTime(time: number | string, isTick?: boolean, isParent?: boolean, parentEasing?: EasingType): this;
    forEach(func: (item: Scene | SceneItem, id: string | number, index: number, items: IObject<Scene | SceneItem>) => void): this;
    toCSS(playCondition?: PlayCondition, duration?: number, parentStates?: AnimatorState[]): string;
    exportCSS(playCondition?: PlayCondition, duration?: number, parentStates?: AnimatorState[]): this;
    append(item: SceneItem | Scene): void;
    pauseCSS(): this;
    pause(): this;
    endCSS(): void;
    end(): this;
    addPlayClass(isPaused: boolean, playClassName?: string, properties?: object): AnimateElement;
    playCSS(isExportCSS?: boolean, playClassName?: string, properties?: Partial<AnimatorState>): this;
    set(properties: any, ...args: any[]): this;
    load(properties?: any, options?: any): this;
    setOptions(options?: Partial<SceneState>): this;
    setSelector(target?: string | boolean | ((id: number | string) => string)): this;
    start(delay?: number): boolean;
}
export default Scene;
