import PropertyObject from "./PropertyObject";
import Scene from "./Scene";
import SceneItem from "./SceneItem";
import { IObject } from "@daybrush/utils";
import { EasingType, EasingFunction, NameType } from "./types";
export declare function isPropertyObject(value: any): value is PropertyObject;
export declare function setAlias(name: string, alias: string[]): void;
export declare function setRole(names: string[], isProperty?: boolean, isFixedProperty?: boolean): void;
export declare function getType(value: any): "boolean" | "symbol" | "undefined" | "object" | "function" | "array" | "property" | "value";
export declare function isPureObject(obj: any): obj is object;
export declare function getNames(names: IObject<any>, stack: string[]): string[][];
export declare function updateFrame(names: IObject<any>, properties: IObject<any>): IObject<any>;
export declare function toFixed(num: number): number;
export declare function getValueByNames(names: Array<string | number>, properties: IObject<any>, length?: number): IObject<any>;
export declare function isInProperties(roles: IObject<any>, args: NameType[], isCheckTrue?: boolean): boolean;
export declare function isRole(args: NameType[], isCheckTrue?: boolean): boolean;
export declare function isFixed(args: NameType[]): boolean;
export interface IterationInterface {
    currentTime: number;
    iterationCount: number;
    elapsedTime: number;
}
export declare function setPlayCSS(item: Scene | SceneItem, isActivate: boolean): void;
export declare function isPausedCSS(item: Scene | SceneItem): boolean;
export declare function isEndedCSS(item: Scene | SceneItem): boolean;
export declare function exportCSS(id: number | string, css: string): void;
export declare function makeId(selector?: boolean): string;
export declare function getRealId(item: Scene | SceneItem): NameType;
export declare function toId(text: number | string): string;
export declare function playCSS(item: Scene | SceneItem, isExportCSS?: boolean, playClassName?: string, properties?: object): void;
export declare function addAnimationEvent(item: Scene | SceneItem, el: Element): void;
export declare function getEasing(curveArray: string | number[] | EasingFunction): EasingType;
